%define anolis_release 1

%undefine _package_note_flags
Name:           ocaml-react
Version:        1.2.2
Release:        %{anolis_release}%{?dist}
Summary:        OCaml framework for Functional Reactive Programming (FRP)

License:        ISC
URL:            http://erratique.ch/software/react
Source0:        http://erratique.ch/software/react/releases/react-%{version}.tbz

BuildRequires:  ocaml >= 4.01.0
BuildRequires:  ocaml-ocamlbuild
BuildRequires:  ocaml-findlib-devel
BuildRequires:  ocaml-ocamldoc
BuildRequires:  ocaml-topkg-devel >= 0.9.0

%description
React is an OCaml module for functional reactive programming (FRP). It
provides support to program with time varying values : declarative
events and signals. React doesn't define any primitive event or
signal; it lets the client choose the concrete timeline.

React is made of a single, independent module and distributed under
the ISC license.

Given an absolute notion of time Rtime helps you to manage a timeline
and provides time stamp events, delayed events and delayed signals.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%package        doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n react-%{version}

# require debug info
echo $'\ntrue: debug' >> _tags

%build
ocaml pkg/pkg.ml build --tests true

%install
mkdir -p $RPM_BUILD_ROOT%{_libdir}/ocaml/react
for f in \
  pkg/META \
  opam \
%ifarch %{ocaml_native_compiler}
  src/*.cmx \
%endif
  src/*.{a,cma,cmi,mli,cmxa,cmxs}
do
  cp -p _build/$f $RPM_BUILD_ROOT%{_libdir}/ocaml/react/
done

%check
ocaml pkg/pkg.ml test

%files
%license LICENSE.md
%dir %{_libdir}/ocaml/react/
%{_libdir}/ocaml/react/META
%{_libdir}/ocaml/react/*.cma
%{_libdir}/ocaml/react/*.cmi
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/react/*.cmxs
%endif

%files devel
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/react/*.a
%{_libdir}/ocaml/react/*.cmx
%{_libdir}/ocaml/react/*.cmxa
%endif
%{_libdir}/ocaml/react/*.mli
%{_libdir}/ocaml/react/opam

%files doc
%doc CHANGES.md README.md

%changelog
* Thu Mar 23 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> - 1.2.2-1
- Init from upstream
